# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NetworkProfileResultContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'str',
        'updated_at': 'str',
        'owner': 'str',
        'owner_type': 'str',
        'org_id': 'str',
        'links': 'object',
        'name': 'str',
        'description': 'str',
        'external_region_id': 'str',
        'cloud_account_id': 'str',
        'isolation_type': 'str',
        'isolation_network_domain_cidr': 'str',
        'isolated_network_cidr_prefix': 'int',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'custom_properties': 'dict(str, str)'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'owner': 'owner',
        'owner_type': 'ownerType',
        'org_id': 'orgId',
        'links': '_links',
        'name': 'name',
        'description': 'description',
        'external_region_id': 'externalRegionId',
        'cloud_account_id': 'cloudAccountId',
        'isolation_type': 'isolationType',
        'isolation_network_domain_cidr': 'isolationNetworkDomainCIDR',
        'isolated_network_cidr_prefix': 'isolatedNetworkCIDRPrefix',
        'tags': 'tags',
        'custom_properties': 'customProperties'
    }

    def __init__(self, id=None, created_at=None, updated_at=None, owner=None, owner_type=None, org_id=None, links=None, name=None, description=None, external_region_id=None, cloud_account_id=None, isolation_type=None, isolation_network_domain_cidr=None, isolated_network_cidr_prefix=None, tags=None, custom_properties=None):  # noqa: E501
        """NetworkProfileResultContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._updated_at = None
        self._owner = None
        self._owner_type = None
        self._org_id = None
        self._links = None
        self._name = None
        self._description = None
        self._external_region_id = None
        self._cloud_account_id = None
        self._isolation_type = None
        self._isolation_network_domain_cidr = None
        self._isolated_network_cidr_prefix = None
        self._tags = None
        self._custom_properties = None
        self.discriminator = None
        self.id = id
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if owner is not None:
            self.owner = owner
        if owner_type is not None:
            self.owner_type = owner_type
        if org_id is not None:
            self.org_id = org_id
        self.links = links
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if external_region_id is not None:
            self.external_region_id = external_region_id
        if cloud_account_id is not None:
            self.cloud_account_id = cloud_account_id
        if isolation_type is not None:
            self.isolation_type = isolation_type
        if isolation_network_domain_cidr is not None:
            self.isolation_network_domain_cidr = isolation_network_domain_cidr
        if isolated_network_cidr_prefix is not None:
            self.isolated_network_cidr_prefix = isolated_network_cidr_prefix
        if tags is not None:
            self.tags = tags
        if custom_properties is not None:
            self.custom_properties = custom_properties

    @property
    def id(self):
        """Gets the id of this NetworkProfileResultContent.  # noqa: E501

        The id of this resource instance  # noqa: E501

        :return: The id of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NetworkProfileResultContent.

        The id of this resource instance  # noqa: E501

        :param id: The id of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this NetworkProfileResultContent.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :return: The created_at of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this NetworkProfileResultContent.

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :param created_at: The created_at of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this NetworkProfileResultContent.  # noqa: E501

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :return: The updated_at of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this NetworkProfileResultContent.

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :param updated_at: The updated_at of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def owner(self):
        """Gets the owner of this NetworkProfileResultContent.  # noqa: E501

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :return: The owner of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this NetworkProfileResultContent.

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :param owner: The owner of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._owner = owner

    @property
    def owner_type(self):
        """Gets the owner_type of this NetworkProfileResultContent.  # noqa: E501

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :return: The owner_type of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._owner_type

    @owner_type.setter
    def owner_type(self, owner_type):
        """Sets the owner_type of this NetworkProfileResultContent.

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :param owner_type: The owner_type of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._owner_type = owner_type

    @property
    def org_id(self):
        """Gets the org_id of this NetworkProfileResultContent.  # noqa: E501

        The id of the organization this entity belongs to.  # noqa: E501

        :return: The org_id of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this NetworkProfileResultContent.

        The id of the organization this entity belongs to.  # noqa: E501

        :param org_id: The org_id of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def links(self):
        """Gets the links of this NetworkProfileResultContent.  # noqa: E501

        hrefs links  # noqa: E501

        :return: The links of this NetworkProfileResultContent.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this NetworkProfileResultContent.

        hrefs links  # noqa: E501

        :param links: The links of this NetworkProfileResultContent.  # noqa: E501
        :type: object
        """
        if links is None:
            raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    @property
    def name(self):
        """Gets the name of this NetworkProfileResultContent.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NetworkProfileResultContent.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this NetworkProfileResultContent.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NetworkProfileResultContent.

        A human-friendly description.  # noqa: E501

        :param description: The description of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def external_region_id(self):
        """Gets the external_region_id of this NetworkProfileResultContent.  # noqa: E501

        The id of the region for which this profile is defined  # noqa: E501

        :return: The external_region_id of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._external_region_id

    @external_region_id.setter
    def external_region_id(self, external_region_id):
        """Sets the external_region_id of this NetworkProfileResultContent.

        The id of the region for which this profile is defined  # noqa: E501

        :param external_region_id: The external_region_id of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._external_region_id = external_region_id

    @property
    def cloud_account_id(self):
        """Gets the cloud_account_id of this NetworkProfileResultContent.  # noqa: E501

        Id of the cloud account this profile belongs to.  # noqa: E501

        :return: The cloud_account_id of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_id

    @cloud_account_id.setter
    def cloud_account_id(self, cloud_account_id):
        """Sets the cloud_account_id of this NetworkProfileResultContent.

        Id of the cloud account this profile belongs to.  # noqa: E501

        :param cloud_account_id: The cloud_account_id of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._cloud_account_id = cloud_account_id

    @property
    def isolation_type(self):
        """Gets the isolation_type of this NetworkProfileResultContent.  # noqa: E501

        Specifies the isolation type e.g. none, subnet or security group  # noqa: E501

        :return: The isolation_type of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._isolation_type

    @isolation_type.setter
    def isolation_type(self, isolation_type):
        """Sets the isolation_type of this NetworkProfileResultContent.

        Specifies the isolation type e.g. none, subnet or security group  # noqa: E501

        :param isolation_type: The isolation_type of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """
        allowed_values = ["NONE", "SUBNET", "SECURITY_GROUP"]  # noqa: E501
        if isolation_type not in allowed_values:
            raise ValueError(
                "Invalid value for `isolation_type` ({0}), must be one of {1}"  # noqa: E501
                .format(isolation_type, allowed_values)
            )

        self._isolation_type = isolation_type

    @property
    def isolation_network_domain_cidr(self):
        """Gets the isolation_network_domain_cidr of this NetworkProfileResultContent.  # noqa: E501

        CIDR of the isolation network domain.  # noqa: E501

        :return: The isolation_network_domain_cidr of this NetworkProfileResultContent.  # noqa: E501
        :rtype: str
        """
        return self._isolation_network_domain_cidr

    @isolation_network_domain_cidr.setter
    def isolation_network_domain_cidr(self, isolation_network_domain_cidr):
        """Sets the isolation_network_domain_cidr of this NetworkProfileResultContent.

        CIDR of the isolation network domain.  # noqa: E501

        :param isolation_network_domain_cidr: The isolation_network_domain_cidr of this NetworkProfileResultContent.  # noqa: E501
        :type: str
        """

        self._isolation_network_domain_cidr = isolation_network_domain_cidr

    @property
    def isolated_network_cidr_prefix(self):
        """Gets the isolated_network_cidr_prefix of this NetworkProfileResultContent.  # noqa: E501

        The CIDR prefix length to be used for the isolated networks that are created with the network profile.  # noqa: E501

        :return: The isolated_network_cidr_prefix of this NetworkProfileResultContent.  # noqa: E501
        :rtype: int
        """
        return self._isolated_network_cidr_prefix

    @isolated_network_cidr_prefix.setter
    def isolated_network_cidr_prefix(self, isolated_network_cidr_prefix):
        """Sets the isolated_network_cidr_prefix of this NetworkProfileResultContent.

        The CIDR prefix length to be used for the isolated networks that are created with the network profile.  # noqa: E501

        :param isolated_network_cidr_prefix: The isolated_network_cidr_prefix of this NetworkProfileResultContent.  # noqa: E501
        :type: int
        """

        self._isolated_network_cidr_prefix = isolated_network_cidr_prefix

    @property
    def tags(self):
        """Gets the tags of this NetworkProfileResultContent.  # noqa: E501

        A set of tag keys and optional values that were set on this Network Profile.  # noqa: E501

        :return: The tags of this NetworkProfileResultContent.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this NetworkProfileResultContent.

        A set of tag keys and optional values that were set on this Network Profile.  # noqa: E501

        :param tags: The tags of this NetworkProfileResultContent.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def custom_properties(self):
        """Gets the custom_properties of this NetworkProfileResultContent.  # noqa: E501

        Additional properties that may be used to extend the Network Profile object that is produced from this specification.  For isolationType security group, datastoreId identifies the Compute Resource Edge datastore. computeCluster and resourcePoolId identify the Compute Resource Edge cluster. For isolationType subnet, distributedLogicalRouterStateLink identifies the on-demand network distributed local router (NSX-V only). For isolationType subnet, tier0LogicalRouterStateLink identifies the on-demand network tier-0 logical router (NSX-T only). onDemandNetworkIPAssignmentType identifies the on-demand network IP range assignment type static, dynamic, or mixed.  # noqa: E501

        :return: The custom_properties of this NetworkProfileResultContent.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this NetworkProfileResultContent.

        Additional properties that may be used to extend the Network Profile object that is produced from this specification.  For isolationType security group, datastoreId identifies the Compute Resource Edge datastore. computeCluster and resourcePoolId identify the Compute Resource Edge cluster. For isolationType subnet, distributedLogicalRouterStateLink identifies the on-demand network distributed local router (NSX-V only). For isolationType subnet, tier0LogicalRouterStateLink identifies the on-demand network tier-0 logical router (NSX-T only). onDemandNetworkIPAssignmentType identifies the on-demand network IP range assignment type static, dynamic, or mixed.  # noqa: E501

        :param custom_properties: The custom_properties of this NetworkProfileResultContent.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NetworkProfileResultContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkProfileResultContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
